#!/usr/bin/env python

import sys, getopt, os.path

##########################################
##
##	default parameters for refineAll
##
##########################################
Usage	=	"Usage: "+sys.argv[0]+" <first-n.mrc> <last-n.mrc> [--mask1=<n>] [--mask2=<n>] [--low=<low res in pixel>] [--high=<high res in pixel>] [--template=<template.mrc>]\n"
ortAllcmd	= "ortAll_mrc"
low		= ""
high		= ""
mask1		= ""
mask2		= ""
template	= ""
##
#########################################

if len(sys.argv) < 3:
	print Usage
	sys.exit(1)
elif len(sys.argv) > 3:
	try:
		optlist, junks = getopt.getopt(sys.argv[3:], 'l:h:t:', ['mask1=','mask2=','low=','high=','template='])
	except getopt.GetoptError:
   		# print help information and exit:
		print Usage
		sys.exit(2)
	if len(junks):
		for o in junks:
			print "Error: option '"+o+"' is not supported"
		print Usage
		sys.exit(3)
	for o, a in optlist:
		if o in ("-l", "--low"):
			low=a
		if o in ("-h", "--high"):
			high=a
		if o in ("-t", "--template"):
			template=a
		if o in ("--mask1",):
			mask1=a
		if o in ("--mask2",):
			mask2=a
			
#############################################################
# Execute ortAll
#############################################################
command = ortAllcmd+" "+sys.argv[1]+" "+sys.argv[2]
if os.path.exists(template): command = command + " " + template
try:
	cmd=os.popen(command,'w') 
	cmd.write("%s\n%s\n" % (mask1,mask2))
	cmd.write("%s %s\n" % (low,high))
	cmd.close()
except KeyboardInterrupt:
	sys.exit(3)
except :
	print sys.argv[0]+": error in running command \""+command+"\""
	sys.exit(4)
		
else:
	print sys.argv[0]+": initial orientation and center parameters are saved to the *.log files\n" 
