#!/usr/bin/env python

import sys, getopt, string, os.path

###############################################
##
##	default parameters for reconstructParallel
##
###############################################
Usage	        = "Usage: "+sys.argv[0]+" <raw-ort.dat> [--script=<file name>] [--ctf=<ctf.dat>] [--diameter=<pixels>] [--res=<pixels>] [--maps=<0|2|3>] [--cpu1=<number of CPU>] [--cpu2=<number of CPU>] [--scale=<num>] [--memo=<info>]\n"
reconstructcmd	= "reconstructParallel"
script			= "reconstruct.script"
ctf				= ""
res				= 36
diameter		= 221
scale           = 1.0   # sampling step scale factor, 2 means 2 times finer sampling step
cpu1			= 1		# cpus for Normal and bigG step
cpu2			= 1		# cpus for emicofb step
maps			= 0		# 
memo			= "just another reconstruction"
##
#########################################

if len(sys.argv) < 2:
	print Usage
	sys.exit(1)
elif len(sys.argv) > 2:
	try:
		optlist, junks = getopt.getopt(sys.argv[2:], 'c:d:r:p:s:m:', ['script=','ctf=','diameter=','res=','maps=','cpus=','cpu1=','cpu2=','scale=','memo='])
	except getopt.GetoptError:
                # print help information and exit:
		print Usage
		sys.exit(2)
	if len(junks):
		for o in junks:
		    print "Error: option '"+o+"' is not supported"
		print Usage
		sys.exit(3)
	for o, a in optlist:
		if o in ("--script",):
			script=a
		elif o in ("-c", "--ctf"):
		    ctf=a
		elif o in ("-d", "--diameter"):
		    diameter=float(a)
		elif o in ("-r", "--res"):
		    res=float(a)
		elif o in ("-m", "--maps"):
		    maps=int(a)
		elif o in ("-p", "--cpus"):
		    cpu1=int(a)
		    cpu2=cpu1
		elif o in ("--cpu1",):
		    cpu1=int(a)
		elif o in ("--cpu2",):
		    cpu2=int(a)
		elif o in ("-s", "--scale"):
		    scale=float(a)
		elif o in ("--memo", ):
		    memo=a
			
#############################################################
# Execute reconstructParallel
#############################################################
if maps not in [0,2,3]: maps=0
command = reconstructcmd +" "+sys.argv[1]+" "+script
try:
	cmd=os.popen(command,'w')
	if ctf: cmd.write("y\n%s\n" % ctf)
	else: cmd.write("n\n")
	cmd.write("%d\n" % diameter)
	cmd.write("%d\n" % res)
	cmd.write("%d\n" % int(diameter*scale))
	cmd.write("%d\n" % cpu1)
	cmd.write("%d\n" % cpu2)
	cmd.write("%d\n" % maps)
	cmd.write("%s\n" % memo)
	cmd.close()
except :
	print sys.argv[0]+": error in running command \""+command+"\""
	sys.exit(3)
