#!/usr/bin/env python

import sys, getopt, string, os.path

##########################################
##
##	default parameters for refineAll
##
##########################################
Usage	=	"Usage: "+sys.argv[0]+" <raw-ort.dat> <ref-ort.dat> [--apix=<A/pixel>] [--cycle=<n>] " + \
			"[--low=<low res in pixel>] [--high=<high res in pixel>] [--ctf=<ctf-curve.dat>] " + \
			"[--amp=<amplitude threshold>] [--rot=<rotation search step size>] [--trans=<translation search step size>] " + \
			"[--phase=<phase threshold>] [--cpu=<number of CPU>] [--out=<filename>]\n"
refinecmd	= "refineAll"
cycles 		= ""
apix			= "3.5"
low 			= "3"
high		= "36"
ctf			= ""
ampthresh	= "1.0"
rotstep		= ""
transstep	= ""
phasethresh	= ""
cpu			= "1"
out			= ""
##
#########################################

if len(sys.argv) < 3:
	print Usage
	sys.exit(1)
elif len(sys.argv) > 3:
	try:
		optlist, junks = getopt.getopt(sys.argv[3:], 'a:c:l:h:r:t:p:', ['cycle=','cpu=','low=','high=','ctf=','apix=','amp=','rot=','trans=','phase=','out='])
	except getopt.GetoptError:
   		# print help information and exit:
		print Usage
		sys.exit(2)
	if len(junks):
		for o in junks:
			print "Error: option '"+o+"' is not supported"
		print Usage
		sys.exit(3)
	for o, a in optlist:
		if o in ("-a", "--apix"):
			apix=a
		if o in ("--amp",):
			ampthresh=string.atof(a)
		if o in ("-l", "--low"):
			low=a
		if o in ("-h", "--high"):
			high=a
		if o in ("-r", "--rot"):
			rotstep=a
		if o in ("-t", "--trans"):
			transstep=a
		if o in ("-p", "--phase"):
			phasethresh=a
		if o in ("--ctf",):
			ctf=a
		if o in ("--out",):
			out=a
		if o in ("-c", "--cpu"):
			cpu=a
		if o in ("--cycle",):
			cycles=a
			
#############################################################
# Delete the existing output dat file to avoid problem
#############################################################
finalout="refinedOrtCenter" + low + "to" + high + ".dat"
if os.path.exists(finalout): 
	print sys.argv[0]+": deleting "+finalout
	os.remove(finalout)

#############################################################
# Execute refineAll
#############################################################
command = refinecmd+" "+sys.argv[1]+" "+sys.argv[2]
if ctf != "":
	command =  command + " -ctf "+ctf 

try:
	cmd=os.popen(command,'w') 
	cmd.write(cycles+"\n")
	cmd.write(apix+"\n")
	cmd.write(low+' '+high+"\n")
	cmd.write(ampthresh+"\n")
	cmd.write(rotstep+"\n")
	cmd.write(transstep+"\n")
	cmd.write(phasethresh+"\n")
	cmd.write(cpu+"\n")
	cmd.close()
except KeyboardInterrupt:
	sys.exit(3)
except:
	if os.path.exists(finalout):os.remove(finalout)
	print sys.argv[0]+": error in running command \""+command+"\""
	sys.exit(4)
else:	
	if out != "" and os.path.exists(finalout):
		os.rename(finalout,out)
		finalout = out;
	print sys.argv[0]+": refined orientation and center parameters are saved to file \"" + finalout + "\"\n" 
